#pragma once
#include "CoreMinimal.h"

namespace ActorLocCSV {  // (H1)
    class ActorLocDiff {
    public:
        const FString Label; // (H2)
        FVector LastLocation, NewLocation;
        FRotator LastRotation, NewRotation;
        bool Updated;

        ActorLocDiff(const FString& Label); // (H3)
        ActorLocDiff(const FString& Label,
            const TArray<FString>& Items); // (H4)
        TArray<FString> ItemStrings(void) const; // (H5)

    private:
        static TArray<FString> StrsOf(const TArray<float>& Floats); // (H6)
        static TArray<float> FloatsOf(const TArray<FString>& Strs); // (H7)
        static TArray<float> FloatsOf(const FVector& Vector); // (H8)
        static TArray<float> FloatsOf(const FRotator& Rotator); // (H9)
        static FVector FVectorOf(const TArray<float>& Floats,
			       const int Index); // (H10)
        static FRotator FRotatorOf(const TArray<float>& Floats,
				 const int Index); // (H11)
    };
}
