// Copyright 1998-2017 Epic Games, Inc. All Rights Reserved.

using UnrealBuildTool;

public class ContoursCaputre2D : ModuleRules
{
	public ContoursCaputre2D(ReadOnlyTargetRules Target) : base(Target)
	{
		PCHUsage = ModuleRules.PCHUsageMode.UseExplicitOrSharedPCHs;
		
		PublicIncludePaths.AddRange(
			new string[] {
				"ContoursCaputre2D/Public"
				// ... add public include paths required here ...
			}
			);
				
		
		PrivateIncludePaths.AddRange(
			new string[] {
				"ContoursCaputre2D/Private",
				// ... add other private include paths required here ...
			}
			);
			
		
		PublicDependencyModuleNames.AddRange(
			new string[]
			{
				"Core",
				// ... add other public dependencies that you statically link with here ...
			}
			);
			
		
		PrivateDependencyModuleNames.AddRange(
			new string[]
			{
				"CoreUObject",
				"Engine",
				"Slate",
				"SlateCore",
				// ... add private dependencies that you statically link with here ...	
			}
			);
		
		
		DynamicallyLoadedModuleNames.AddRange(
			new string[]
			{
				// ... add any modules that your module loads dynamically here ...
			}
			);

        PublicIncludePaths.Add(ModuleDirectory + "/lib/"); // (1)
        if (Target.Platform == UnrealTargetPlatform.Win64) {
            PublicAdditionalLibraries.Add(ModuleDirectory + "/lib/contours_lib.lib"); // (W2)
            PublicAdditionalLibraries.Add(ModuleDirectory + "/lib/opencv_world331.lib"); // (W3)
            var DLLPath = ModuleDirectory + "/../../Binaries/Win64/opencv_world331.dll"; // (W4)
            PublicDelayLoadDLLs.Add(DLLPath);
            RuntimeDependencies.Add(new RuntimeDependency(DLLPath));
        }
        if (Target.Platform == UnrealTargetPlatform.Mac) {
            PublicAdditionalLibraries.Add(ModuleDirectory + "/lib/libcontours_lib.a"); // (M2)
            var DLLPath_core = ModuleDirectory + "/../../Binaries/Mac/libopencv_core.3.3.1.dylib"; // (M3)
            var DLLPath_imgproc = ModuleDirectory + "/../../Binaries/Mac/libopencv_imgproc.3.3.1.dylib"; // (M4)
            PublicDelayLoadDLLs.Add(DLLPath_core);
            PublicDelayLoadDLLs.Add(DLLPath_imgproc);
            RuntimeDependencies.Add(new RuntimeDependency(DLLPath_core));
            RuntimeDependencies.Add(new RuntimeDependency(DLLPath_imgproc));
        }
    }
}
