#pragma once

#include "CoreMinimal.h"
#include "Components/SceneCaptureComponent2D.h"
#include "Runtime/Engine/Classes/Engine/TextureRenderTarget2D.h"
#include "ContoursCaptureComponent2D.generated.h"

UCLASS(ClassGroup = Rendering, meta = (BlueprintSpawnableComponent))
class UContoursCaptureComponent2D : public USceneCaptureComponent2D  // (H1)
{
	GENERATED_BODY()
	
public:
    UContoursCaptureComponent2D();
    
    UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "UE C++ book")
    FVector2D CanvasSize; // (H2)

    UFUNCTION(BlueprintCallable, Category = "UE C++ book")
    int32 NumberOfContours(); // (H3)

    UFUNCTION(BlueprintCallable, Category = "UE C++ book")
    TArray<FVector2D> ContourOfIndex(const int32 Index); // (H4)

private:
    TArray<TArray<FVector2D>> Contours; // (H5)

    void CalculateContours(const TArray<FColor>& Colors); // (H6)
};
