#pragma once

#include "CoreMinimal.h"
#include "Editor/UnrealEd/Public/EdMode.h"

class FMeshEditMode : public FEdMode { // (H1)
public:
    const static FEditorModeID MeshEditModeID; // (H2)

    static void Register(void); // (H3)
    virtual void Tick(FEditorViewportClient* ViewportClient,
		      float DeltaTime) override; // (H4)

private:
    static bool IsRegistered; // (H5)
    UPROPERTY() AActor* PrevEditingActor = nullptr; // (H6)

    static AActor* GenProceduralMeshActor(AActor* Actor); // (H7)
    static void AddMeshesToVertices(AActor* PMActor); // (H8)
    static void UpdateMesh(AActor* PMActor); // (H9)
};
