#include "WriteActorLocationFunction.h"
#include "Engine.h"
#include <string>
#include <fstream>

auto UWriteActorLocationFunction::WriteLocation(AActor* Actor)
-> bool {
	if (!Actor) return false;

	FString filepath_str =
		FPaths::ProjectLogDir() / "ActorLocation.txt"; // (1)
	const std::string filepath(TCHAR_TO_UTF8(*filepath_str)); // (2)

	FString label_str = Actor->GetActorLabel(); // (3)
	const std::string label(TCHAR_TO_UTF8(*label_str));
	FVector location = Actor->GetActorLocation(); // (4)

	std::ofstream ostr(filepath, std::ios::app); // (5)
	ostr << label << ":"
		<< location.X << ","
		<< location.Y << ","
		<< location.Z << std::endl; // (6)

	return true;
}


