# MyPluginAppプロジェクトについて

---
## 利用前の準備

ここにはVisual Studio向けやXcode向けのプロジェクトファイルは用意されていません。
以下の手順でプロジェクトファイルを生成して下さい。

### Windowsの場合

 「MyPluginApp.uproject」を右クリックして表示されるコンテキストメニューから「Generate Visual Studio project files」を選択して下さい。
Visual Studioのソリューションファイル 「MyPluginApp.sln」が生成されます。

### macOSの場合

ターミナルから以下のコマンドを実行して下さい。
UE_4.18及びプロジェクトのディレクトリはご自身の環境に合わせて適時読み替えて下さい。
(手元の環境ではUE_4.18のディレクトリは「/Users/Shared/Epic Games/UE_4.18/」でした。)

    $ cd <UE_4.18のインストールディレクトリ>/Engine/Build/BatchFiles/Mac
    $ ./GenerateProjectFiles.sh -project="<MyPluginAppのディレクトリ>/MyPluginApp.uproject" -game

Xcodeのワークスペースファイル「MyPluginApp.xcworkspace」が生成されます。
なお、MyPluginAppのディレクトリパスに空白が含まれていると生成処理が途中で停止しますので注意して下さい。


---
## 内容紹介

本文のCh.7からCh.10までに対応するソースコードはこのプロジェクトに含まれています。
(Ch.3からCh.6については、「MySomeCppApp」プロジェクトを参照して下さい。)
ソースコードはPluginsディレクトリに格納されています。

### Ch.7

Plugins\WriteActorLocationディレクトリ以下を参照して下さい。

### Ch.8

Plugins\ActorLocCSVディレクトリ以下を参照して下さい。

### Ch.9

Plugins\ContoursCapture2Dディレクトリ以下を参照して下さい。
ContoursLibWin, ContoursLibMacプロジェクトも参照して下さい。

### Ch.10

Plugins\MeshEditディレクトリ以下を参照して下さい。

---
## ライセンスについて

以下に列挙されたファイルはOpenCVの一部です。
これらのファイルのライセンスは同梱の「LICENSE_OpenCV.txt」に従います。

- Plugins\ContoursCaputre2D\Source\ContoursCaputre2D\lib\opencv_world331.lib
- Plugins\ContoursCaputre2D\Binaries\Win64\opencv_world331.dll
- Plugins\ContoursCaputre2D\Binaries\Mac\libopencv_core.3.3.1.dylib
- Plugins\ContoursCaputre2D\Binaries\Mac\libopencv_imgproc.3.3.1.dylib

---

以上です。

2018.02.12 鈴木晃